//========================================================
//Universe.h
//========================================================
//  This is the main header which defines the "universe"
// data type:  This is a BList of "star systems", which also
// are defined here.

#ifndef UNIVERSE_H
#define UNIVERSE_H

  #if BUILDNG_UNIVERSE_H
    #define UNIVERSE_IMPEXP_TYPED __declspec(dllexport)
  #else
    #define UNIVERSE_IMPEXP_TYPED __declspec(dllimport)
  #endif

#include <Aggregate++.h>
#include <String.h>
#include "StarSystem.h"

class UNIVERSE_IMPEXP_TYPED Universe:public aggregatef
{
  public:
    // constructors    
    Universe(); Universe(BMessage *);
    
    //Inherited functions
    virtual status_t Archive(BMessage *,bool) const;	//from BArchivable
    static BArchivable *Instantiate(BMessage *);		//from BArchivable
    
    //New functions
    void Save(BFile *);
    static Universe *Open(BFile *);
};

#endif