#define BUILDING_STARSYSTEM_H 1

#include "StarSystem.h"
#include <iostream.h>

System::System()
{
  systemname = new BString("Star");
  location.x = 1.0f; location.y = 1.0f; location.z = 1.0f;
};

System::System(BMessage *msg_archive)
  :pointf(msg_archive)
{
  const char *tempname;
    msg_archive->FindString("Systemname",&tempname);
  systemname = new BString(tempname);
};

status_t System::Archive(BMessage *msg_archive, bool deep) const
{
    msg_archive->AddString("GType", "STAR");
    pointf::Archive(msg_archive, deep);
    msg_archive->AddString("Systemname",systemname->String());
    msg_archive->AddString("class","System");
  return B_OK;
};

BArchivable *System::Instantiate(BMessage *msg_archive)
{
  return new System(msg_archive);
};

System::~System()
{
  delete systemname;
};

